﻿using System;

namespace TypyOgólne
{
    using ParaInt = Para<int, int>;    

    static class Program
    {
        static void Drukuj<T>(this T[] tablica, string nagłówek)
        {
            Console.WriteLine(typeof(T).Name + " " + nagłówek);
            foreach (T element in tablica)
                Console.WriteLine(element.ToString());
        }

        static void Main(string[] args)
        {
            Random r = new Random();

            //int
            //Para<int>[] pi = new Para<int>[10];
            ParaInt[] pi = new ParaInt[10];
            for (int i = 0; i < pi.Length; i++)
                pi[i] = new ParaInt(r.Next(10), r.Next(10));
            pi.Drukuj("przed sortowaniem");
            Array.Sort(pi);
            pi.Drukuj("po sortowaniu");

            //double
            Para<int,double>[] pd = new Para<int,double>[10];
            for (int i = 0; i < pd.Length; i++)
                pd[i] = new Para<int,double>(r.Next(10), 10*r.NextDouble());
            pd.Drukuj("przed sortowaniem");
            Array.Sort(pd);
            pd.Drukuj("po sortowaniu");
        }
    }


    class Para<T,S> 
        : IComparable<Para<T,S>> 
        where T : IComparable<T>
        where S : IComparable<S>
    {
        private T pierwszy = default(T);
        private S drugi = default(S);

        public Para(T pierwszy, S drugi)
        {
            this.pierwszy = pierwszy;
            this.drugi = drugi;
        }

        public override string ToString()
        {
            return pierwszy.ToString() + "\t" + drugi.ToString();
        }

        public int CompareTo(Para<T,S> innaPara)
        {
            int wartość = pierwszy.CompareTo(innaPara.pierwszy);
            if (wartość != 0) return wartość;
            else return drugi.CompareTo(innaPara.drugi);
        }
    }
}
